Procedure Main(cMinNum, cMaxNum)
LOCAL nMinNum := iif(PCount() == 2, val(cMinNum), 1)
LOCAL nMaxNum := iif(PCount() == 2, val(cMaxNum), iif(PCount() == 1, val(cMinNum), 0))

	if .not. empty(cMinNum)
		Random_Number(Min(nMinNum, nMaxNum), Max(nMinNum, nMaxNum))
	else
		********************************************************
		* Number Ranges (Minimum and Maximum Values specified) *
		********************************************************
		Random_Number(    -12345,  54321)	// Negative to Positive ( 66,667 values -- small Gaps)
		Random_Number(    -15000,  15000)	// Negative to Positive ( 30,001 values -- no Gaps)
		Random_Number(    -18300,     -5)	// Negative to Negative ( 18,296 values -- 18,297 values for RandomInt())
		Random_Number(    123456, 789012)	// Positive to Positive (665,557 values -- large Gaps)
		**********************************************
		* Number Ranges (Minimum Value of 1 implied) *
		**********************************************
		Random_Number(      1074)			//       0x432 /                             100-0011-0010 / (11 Bits)
		Random_Number(      2306)			//       0x902 /                            1001-0000-0010 / (12 Bits)
		Random_Number(      4128)			//      0x1020 /                          1-0000-0010-0000 / (13 Bits)
		Random_Number(     12526)			//      0x30EE /                         11-0000-1110-1110 / (14 Bits)
		Random_Number(     16419)			//      0x4023 /                        100-0000-0010-0011 / (15 Bits)
		Random_Number(     36897)			//      0x9021 /                       1001-0000-0010-0001 / (16 Bits)
		Random_Number(     69792)			//     0x110A0 /                     1-0001-0000-1010-0000 / (17 Bits)
		Random_Number(    192560)			//     0x2F030 /                    10-1111-0000-0011-0000 / (18 Bits)
		Random_Number(    306125)			//     0x4ABCD /                   100-1010-1011-1100-1101 / (19 Bits)
		Random_Number(    786688)			//     0xC0100 /                  1100-0000-0001-0000-0000 / (20 Bits)
		Random_Number(   1114624)			//    0x110200 /                1-0001-0000-0010-0000-0000 / (21 Bits)
		***************************************************************************
		* The remainder will not run, as the Test Array will exhaust all Memory!  *
		* Saving the values instead to a database should work, but might be slow! *
		***************************************************************************
*		Random_Number(   2312022)			//    0x234756 /               10-0011-0100-0111-0101-0110 / (22 Bits)
*		Random_Number(   4342784)			//    0x424400 /              100-0010-0100-0100-0000-0000 / (23 Bits)
*		Random_Number(  10141680)			//    0x9ABFF0 /             1001-1010-1011-1111-1111-0000 / (24 Bits)
*		Random_Number(  17829792)			//   0x1100FA0 /           1-0001-0000-0000-1111-1010-0000 / (25 Bits)
*		Random_Number(  35861573)			//   0x2233445 /          10-0010-0011-0011-0100-0100-0101 / (26 Bits)
*		Random_Number(  67108865)			//   0x4000001 /         100-0000-0000-0000-0000-0000-0001 / (27 Bits)
*		Random_Number( 134217730)			//   0x8000002 /        1000-0000-0000-0000-0000-0000-0010 / (28 Bits)
*		Random_Number( 268435456)			//  0x10000000 /      1-0000-0000-0000-0000-0000-0000-0000 / (29 Bits)
*		Random_Number( 878082192)			//  0x34567890 /     11-0100-0101-0110-0111-1000-1001-0000 / (30 Bits)
*		Random_Number(1253891827)			//  0x4ABCDEF3 /    100-1010-1011-1100-1101-1110-1111-0011 / (31 Bits)
*		Random_Number(2148528212)			//  0x800FF054 /   1000-0000-0000-1111-1111-0000-0101-0100 / (32 Bits)
*		Random_Number(4886718345)			// 0x123456789 / 1-0010-0011-0100-0101-0110-0111-1000-1001 / (33 Bits)
	endif
return

Procedure Random_Number(nMinNum, nMaxNum)
LOCAL nLowNo  := iif(PCount() == 2, nMinNum, 1)
LOCAL nHighNo := iif(PCount() == 2, nMaxNum, iif(PCount() == 1, nMinNum, 0))
LOCAL nValues := nHighNo - nLowNo + iif(nHighNo < 0, 2, 1)
LOCAL aArray  := Array(nValues, 2)
LOCAL nOffset := iif(nLowNo > 0, 1 - nLowNo, 1 + abs(nLowNo))
LOCAL nRounds := 5000000
LOCAL nCount  := 0

	Set Alternate To 'Test_' + alltrim(str(nLowNo)) + '_to_' + alltrim(str(nHighNo)) + '.csv'
	Set Alternate On

	?? "Random Number, RandomInt(), AGP_RandomInt()"

	for nCount := 1 to nValues
		aArray[nCount, 1] := 0
		aArray[nCount, 2] := 0
	next

	if (nRounds / nValues) < 100
		nRounds := 100 * nValues
	endif

	for nCount := 1 to nRounds
		aArray[nOffset +     RandomInt(nLowNo, nHighNo), 1]++
		aArray[nOffset + AGP_RandomInt(nLowNo, nHighNo), 2]++
	next

	for nCount := 1 to nValues
		? str(nCount + nLowNo - 1) + ', ' + str(aArray[nCount, 1]) + ', ' + str(aArray[nCount, 2])
	next

	Set Alternate To
	Set Alternate Off

	? "-------------------------------------"
	?
return

Function AGP_RandomInt(nFrom, nTo)
LOCAL nMinVal := iif(PCount() == 2, nFrom, 1)
LOCAL nMaxVal := iif(PCount() == 2, nTo, iif(PCount() == 1, nFrom, 0))
LOCAL nRange  := nMaxVal - nMinVal							// Actual Range of Values
LOCAL nCutOff := 0x4000										// 0x4000 / 16,384 / 14 Bits
LOCAL nFactor := (0x8000 / nCutOff)							// 0x8000 / 32,767 / 15 Bits (Max Values)
LOCAL nSteps  := Round(nRange / nCutOff, 0)					// (Twice the) Number of Gaps
LOCAL nRandom := 0

	if nMaxVal > 2147483647 .or. nMinVal < -2147483648		// More than 31 bits (> 0xFFFFfFFF)
		return (1)											// ==> 1, becaue signed numbers larger than 31 bits can't be handled by RandomInt()

	elseif nRange < nCutOff									// Use default Routine
		return (RandomInt(nFrom, nTo))						// ==> 1 to nMaxVal (or 0 to 1)
	endif

	while .t.
		nRandom := RandomInt(nMinVal, nMaxVal)
		if RandomInt() == 0
			nRandom += Round((RandomInt(nSteps) - 1) / nFactor, 0)
		else
			nRandom -= Round((RandomInt(nSteps) - 1) / nFactor, 0)
		endif
		if nRandom >= nMinVal .and. nRandom <= nMaxVal
			exit
		endif
	enddo
return (nRandom)
